//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A8AD2F3021E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A8AD2F3021E.cm

//## begin module%3A8AD2F3021E.cp preserve=no
//## end module%3A8AD2F3021E.cp

//## Module: ComponentBase%3A8AD2F3021E; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/ComponentBase.h

#ifndef COMPONENTBASE_H
#define COMPONENTBASE_H 1

//## begin module%3A8AD2F3021E.additionalIncludes preserve=no
//## end module%3A8AD2F3021E.additionalIncludes

//## begin module%3A8AD2F3021E.includes preserve=yes
// xsTypes
#include "xsTypes.h"
// Error
#include <XSUtil/Error/Error.h>
//## end module%3A8AD2F3021E.includes

//## begin module%3A8AD2F3021E.declarations preserve=no
//## end module%3A8AD2F3021E.declarations

//## begin module%3A8AD2F3021E.additionalDeclarations preserve=yes
class Parameter;
class ModParam;
class CGroupBase;
class XSModelFunction;
class MixBase;
class UniqueEnergy;
#include <map>
#include <set>
//## end module%3A8AD2F3021E.additionalDeclarations


//## begin ComponentBase%3A8AD229032B.preface preserve=yes
//## end ComponentBase%3A8AD229032B.preface

//## Class: ComponentBase%3A8AD229032B
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3E3183B5031C;XSModelFunction { -> F}

class ComponentBase 
{
  //## begin ComponentBase%3A8AD229032B.initialDeclarations preserve=yes
  //## end ComponentBase%3A8AD229032B.initialDeclarations

  public:
    //## Class: InvalidInput%376E636EBF50
    //	Invalid input exception for component object.
    //	    //	Thrown if component name entered is too short (1
    //	character)
    //	Thrown if component name entered is too short (1
    //	character)
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%3804B648ECFF; { -> }
    //## Uses: <unnamed>%37FA3DAD0E70;Component { -> }

    class InvalidInput : public YellowAlert  //## Inherits: <unnamed>%376E63CB7B88
    {
      public:
        //## Constructors (specified)
          //## Operation: InvalidInput%376E63DE30B0;    C++
          //	Class Component::InvalidInput
          InvalidInput (const string& errMessage = "Invalid Input:");

      protected:
      private:
      private: //## implementation
    };

    //## Class: InvalidTableModel%3D5AC15C030E
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidTableModel : public YellowAlert  //## Inherits: <unnamed>%3D5AC27F0229
    {
      public:
        //## Constructors (generated)
          InvalidTableModel();

      protected:
      private:
      private: //## implementation
    };

    //## Class: NoSuchComponent%3F1D7263039A
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoSuchComponent 
    {
      public:
      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      ComponentBase(const ComponentBase &right);

    //## Constructors (specified)
      //## Operation: ComponentBase%3A9E7D2802F0
      ComponentBase (CGroupBase* p);

    //## Destructor (generated)
      ~ComponentBase();

    //## Assignment Operation (generated)
      ComponentBase & operator=(const ComponentBase &right);


    //## Other Operations (specified)
      //## Operation: clone%3A8AD88202FD
      ComponentBase* clone () const;

      //## Operation: parameterSet%3A8AE4CD034F
      const Parameter* parameterSet (const string& name) const;

      //## Operation: parameterSet%3A8AE4FC0227
      Parameter* parameterSet (const string& name, Parameter* value);

      //## Operation: parentName%3A9E91790052
      const string& parentName () const;

      //## Operation: dataGroup%3A9E951100F8
      size_t dataGroup () const;

      //## Operation: deleteParameters%3DD11CE00221
      //## Exceptions: ()
      void deleteParameters () throw ();

      //## Operation: registerParameters%3A9EA6A101BB
      void registerParameters () const;

      //## Operation: parameterSet%3AD372590275
      const std::vector<Parameter*>& parameterSet () const;

      //## Operation: parameterIndexBase%3AA3FB7F028F
      size_t parameterIndexBase () const;

      //## Operation: reindexParameters%3AA40DB10198
      void reindexParameters (int parameterOffset);

      //## Operation: parameter%3C6D3D4A03DE
      Parameter* parameter (const string& paramName) const;

      //## Operation: incrementModelParameterCount%3AA5580B00B3
      //	Add one to component count and paramIncrement to
      //	parameter count for the containing model.
      size_t incrementModelParameterCount ();

      //## Operation: incrementModelComponentCount%3AA558B5036E
      //	Add one to component count and paramIncrement to
      //	parameter count for the containing model.
      size_t incrementModelComponentCount ();

      //## Operation: modelIndex%3AA6969F0358
      size_t modelIndex () const;

      //## Operation: getLocalParameter%3AA92D860166
      Parameter* getLocalParameter (size_t i) const;

      //## Operation: localParameter%3AA9373000E1
      Parameter* localParameter (size_t i) const;

      //## Operation: numParams%3B9790F300E1
      size_t& numParams ();

      //## Operation: linkParametersToPrimary%3AB2396203A8
      void linkParametersToPrimary ();

      //## Operation: getEnergyArray%3AD31FCE02AA
      const ArrayContainer& getEnergyArray () const;

      //## Operation: modfileLocation%3C0CE9F501A0
      size_t modfileLocation () const;

      //## Operation: modfileSource%3C0CEA04012D
      string modfileSource () const;

      //## Operation: clearArrays%3C7670E30175
      void clearArrays (const std::set<UniqueEnergy*>& currentEngs);

      //## Operation: getVariableParameters%3C7BA9530037
      std::vector<ModParam*> getVariableParameters () const;

      //## Operation: cloneParameters%3DD11C470041
      std::vector<Parameter*> cloneParameters (ComponentBase* newParent) const;

      //## Operation: resequenceParameters%3F0C5FF901A7
      int resequenceParameters (int startValue);

      //## Operation: deregisterParameters%3F2980050068
      void deregisterParameters () const;

      //## Operation: parent%42273BD602CB
      const CGroupBase* parent () const;

      //## Operation: getUniqueEnergies%43D650DF00EE
      const std::set<UniqueEnergy*>& getUniqueEnergies () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: name%3A8AD9D0015D
      //	The name of the model component as declared in
      //	the model.dat file
      const string& name () const;
      void name (const string& value);

      //## Attribute: index%3A8AD9D70387
      //	The global index of the component by order of
      //	construction.
      //
      //	May only be changed through the Components::reindex
      //	operation.
      const int index () const;
      void index (int value);

      //## Attribute: maxEnergy%3A8AD9DE01CB
      //	The maximum energy bin for the component
      const Real maxEnergy () const;
      void maxEnergy (Real value);

      //## Attribute: minEnergy%3A8AD9E40397
      //	minimum energy for the component
      const Real minEnergy () const;
      void minEnergy (Real value);

      //## Attribute: numParams%3A8AD9F501A3
      size_t numParams () const;
      void numParams (size_t value);

      //## Attribute: error%3AD348E400E5
      const bool error () const;
      void error (bool value);

      //## Attribute: compute%3C20E0DD0057
      //	Flag to control recomputation of components. Should be
      //	set true if any of the parameters have been changed.
      bool compute () const;
      void compute (bool value);

      //## Attribute: fluxSaved%3CB5E95902BA
      const bool fluxSaved () const;
      void fluxSaved (bool value);

      //## Attribute: initString%3E36FBC20380
      const string& initString () const;
      void initString (const string& value);

      //## Attribute: isSpectrumDependency%43E8E45302AA
      bool isSpectrumDependency () const;
      void isSpectrumDependency (bool value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::<unnamed>%3A8ADC01009F
      //## Role: ComponentBase::parameterSet%3A8ADC0100A1
      //## Qualifier: index%3A8ADC0100A2; size_t
      std::vector<Parameter*>& parameterSet ();
      void parameterSet (const std::vector<Parameter*>& value);
      Parameter* parameterSet (size_t index);
      void parameterSet (size_t index, Parameter* value);

      //## Association: XSModel::Model::Component::<unnamed>%3A9E7CF900D3
      //## Role: ComponentBase::parent%3A9E7CF900D5
      CGroupBase* parent ();
      void parent (CGroupBase* value);

      //## Association: XSModel::Model::Component::<unnamed>%3E31819E0311
      //## Role: ComponentBase::generator%3E31819F0191
      const XSModelFunction* generator () const;
      void generator (XSModelFunction* value);

      //## Association: XSModel::Model::Component::<unnamed>%3F6F217902A2
      //## Role: ComponentBase::mixGenerator%3F6F217A01B6
      MixBase* mixGenerator () const;
      void mixGenerator (MixBase* value);

      //## Association: XSModel::Model::Component::<unnamed>%43D6A827013C
      //## Role: ComponentBase::uniquePhotonArray%43D6A8280155
      //## Qualifier: uniqueEnergy%43D6A9B302E3; const UniqueEnergy*
      const UniquePhotonContainer& uniquePhotonArray () const;
      void setUniquePhotonArray (const UniquePhotonContainer& value);
      RealArray& uniquePhotonArray (const UniqueEnergy* uniqueEnergy);
      void uniquePhotonArray (const UniqueEnergy* uniqueEnergy, const RealArray& value);

      //## Association: XSModel::Model::Component::<unnamed>%43D6AE440176
      //## Role: ComponentBase::uniquePhotonErrArray%43D6AE450209
      //## Qualifier: uniqueEnergy%43D6AE9F0224; const UniqueEnergy*
      const UniquePhotonContainer& uniquePhotonErrArray () const;
      void setUniquePhotonErrArray (const UniquePhotonContainer& value);
      RealArray& uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy);
      void uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy, const RealArray& value);

      //## Association: XSModel::Model::Component::<unnamed>%43D6B00E0252
      //## Role: ComponentBase::savedUniquePhotonArray%43D6B00F032F
      //## Qualifier: uniqueEnergy%43D6B03500B3; const UniqueEnergy*
      const UniquePhotonContainer& savedUniquePhotonArray () const;
      void setSavedUniquePhotonArray (const UniquePhotonContainer& value);
      RealArray& savedUniquePhotonArray (const UniqueEnergy* uniqueEnergy);
      void savedUniquePhotonArray (const UniqueEnergy* uniqueEnergy, const RealArray& value);

  public:
    // Additional Public Declarations
      //## begin ComponentBase%3A8AD229032B.public preserve=yes
      //## end ComponentBase%3A8AD229032B.public

  protected:

    //## Other Operations (specified)
      //## Operation: swap%3A8AD8070133
      //## Exceptions: ()
      void swap (ComponentBase& right) throw ();

    // Additional Protected Declarations
      //## begin ComponentBase%3A8AD229032B.protected preserve=yes
      //## end ComponentBase%3A8AD229032B.protected

  private:
    // Additional Private Declarations
      //## begin ComponentBase%3A8AD229032B.private preserve=yes
      //## end ComponentBase%3A8AD229032B.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ComponentBase::name%3A8AD9D0015D.attr preserve=no  public: string {U} ""
      string m_name;
      //## end ComponentBase::name%3A8AD9D0015D.attr

      //## begin ComponentBase::index%3A8AD9D70387.attr preserve=no  public: int {U} 0
      int m_index;
      //## end ComponentBase::index%3A8AD9D70387.attr

      //## begin ComponentBase::maxEnergy%3A8AD9DE01CB.attr preserve=no  public: Real {U} 0.
      Real m_maxEnergy;
      //## end ComponentBase::maxEnergy%3A8AD9DE01CB.attr

      //## begin ComponentBase::minEnergy%3A8AD9E40397.attr preserve=no  public: Real {U} 0.
      Real m_minEnergy;
      //## end ComponentBase::minEnergy%3A8AD9E40397.attr

      //## begin ComponentBase::numParams%3A8AD9F501A3.attr preserve=no  public: size_t {U} 0
      size_t m_numParams;
      //## end ComponentBase::numParams%3A8AD9F501A3.attr

      //## begin ComponentBase::error%3AD348E400E5.attr preserve=no  public: bool {U} false
      bool m_error;
      //## end ComponentBase::error%3AD348E400E5.attr

      //## begin ComponentBase::compute%3C20E0DD0057.attr preserve=no  public: bool {U} true
      bool m_compute;
      //## end ComponentBase::compute%3C20E0DD0057.attr

      //## begin ComponentBase::fluxSaved%3CB5E95902BA.attr preserve=no  public: bool {U} false
      bool m_fluxSaved;
      //## end ComponentBase::fluxSaved%3CB5E95902BA.attr

      //## begin ComponentBase::initString%3E36FBC20380.attr preserve=no  public: string {U} ""
      string m_initString;
      //## end ComponentBase::initString%3E36FBC20380.attr

      //## begin ComponentBase::isSpectrumDependency%43E8E45302AA.attr preserve=no  public: bool {U} 
      bool m_isSpectrumDependency;
      //## end ComponentBase::isSpectrumDependency%43E8E45302AA.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3A8ADC01009F
      //## begin ComponentBase::parameterSet%3A8ADC0100A1.role preserve=no  public: Parameter {1 -> 1..nRFHN}
      std::vector<Parameter*> m_parameterSet;
      //## end ComponentBase::parameterSet%3A8ADC0100A1.role

      //## Association: XSModel::Model::Component::<unnamed>%3A9E7CF900D3
      //## begin ComponentBase::parent%3A9E7CF900D5.role preserve=no  public: CGroupBase { -> 1RFHgN}
      CGroupBase* m_parent;
      //## end ComponentBase::parent%3A9E7CF900D5.role

      //## Association: XSModel::Model::Component::<unnamed>%3E31819E0311
      //## begin ComponentBase::generator%3E31819F0191.role preserve=no  public: XSModelFunction { -> 1RFHgN}
      XSModelFunction* m_generator;
      //## end ComponentBase::generator%3E31819F0191.role

      //## Association: XSModel::Model::Component::<unnamed>%3F6F217902A2
      //## begin ComponentBase::mixGenerator%3F6F217A01B6.role preserve=no  public: MixBase { -> 1RFHgN}
      MixBase* m_mixGenerator;
      //## end ComponentBase::mixGenerator%3F6F217A01B6.role

      //## Association: XSModel::Model::Component::<unnamed>%43D6A827013C
      //## begin ComponentBase::uniquePhotonArray%43D6A8280155.role preserve=no  public: UniquePhotonContainer { -> 1..nVHgN}
      UniquePhotonContainer m_uniquePhotonArray;
      //## end ComponentBase::uniquePhotonArray%43D6A8280155.role

      //## Association: XSModel::Model::Component::<unnamed>%43D6AE440176
      //## begin ComponentBase::uniquePhotonErrArray%43D6AE450209.role preserve=no  public: UniquePhotonContainer { -> 1..nVHgN}
      UniquePhotonContainer m_uniquePhotonErrArray;
      //## end ComponentBase::uniquePhotonErrArray%43D6AE450209.role

      //## Association: XSModel::Model::Component::<unnamed>%43D6B00E0252
      //## begin ComponentBase::savedUniquePhotonArray%43D6B00F032F.role preserve=no  public: UniquePhotonContainer { -> 1..nVHgN}
      UniquePhotonContainer m_savedUniquePhotonArray;
      //## end ComponentBase::savedUniquePhotonArray%43D6B00F032F.role

    // Additional Implementation Declarations
      //## begin ComponentBase%3A8AD229032B.implementation preserve=yes
      //## end ComponentBase%3A8AD229032B.implementation

};

//## begin ComponentBase%3A8AD229032B.postscript preserve=yes
//## end ComponentBase%3A8AD229032B.postscript

// Class ComponentBase::InvalidInput 

// Class ComponentBase::InvalidTableModel 

// Class ComponentBase::NoSuchComponent 

// Class ComponentBase 


//## Other Operations (inline)
inline const std::vector<Parameter*>& ComponentBase::parameterSet () const
{
  //## begin ComponentBase::parameterSet%3AD372590275.body preserve=yes
  //## end ComponentBase::parameterSet%3AD372590275.body

  return m_parameterSet;
}

inline const CGroupBase* ComponentBase::parent () const
{
  //## begin ComponentBase::parent%42273BD602CB.body preserve=yes
    return m_parent;
  //## end ComponentBase::parent%42273BD602CB.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& ComponentBase::name () const
{
  //## begin ComponentBase::name%3A8AD9D0015D.get preserve=no
  return m_name;
  //## end ComponentBase::name%3A8AD9D0015D.get
}

inline void ComponentBase::name (const string& value)
{
  //## begin ComponentBase::name%3A8AD9D0015D.set preserve=no
  m_name = value;
  //## end ComponentBase::name%3A8AD9D0015D.set
}

inline const int ComponentBase::index () const
{
  //## begin ComponentBase::index%3A8AD9D70387.get preserve=no
  return m_index;
  //## end ComponentBase::index%3A8AD9D70387.get
}

inline void ComponentBase::index (int value)
{
  //## begin ComponentBase::index%3A8AD9D70387.set preserve=no
  m_index = value;
  //## end ComponentBase::index%3A8AD9D70387.set
}

inline const Real ComponentBase::maxEnergy () const
{
  //## begin ComponentBase::maxEnergy%3A8AD9DE01CB.get preserve=no
  return m_maxEnergy;
  //## end ComponentBase::maxEnergy%3A8AD9DE01CB.get
}

inline void ComponentBase::maxEnergy (Real value)
{
  //## begin ComponentBase::maxEnergy%3A8AD9DE01CB.set preserve=no
  m_maxEnergy = value;
  //## end ComponentBase::maxEnergy%3A8AD9DE01CB.set
}

inline const Real ComponentBase::minEnergy () const
{
  //## begin ComponentBase::minEnergy%3A8AD9E40397.get preserve=no
  return m_minEnergy;
  //## end ComponentBase::minEnergy%3A8AD9E40397.get
}

inline void ComponentBase::minEnergy (Real value)
{
  //## begin ComponentBase::minEnergy%3A8AD9E40397.set preserve=no
  m_minEnergy = value;
  //## end ComponentBase::minEnergy%3A8AD9E40397.set
}

inline size_t ComponentBase::numParams () const
{
  //## begin ComponentBase::numParams%3A8AD9F501A3.get preserve=no
  return m_numParams;
  //## end ComponentBase::numParams%3A8AD9F501A3.get
}

inline void ComponentBase::numParams (size_t value)
{
  //## begin ComponentBase::numParams%3A8AD9F501A3.set preserve=no
  m_numParams = value;
  //## end ComponentBase::numParams%3A8AD9F501A3.set
}

inline const bool ComponentBase::error () const
{
  //## begin ComponentBase::error%3AD348E400E5.get preserve=no
  return m_error;
  //## end ComponentBase::error%3AD348E400E5.get
}

inline void ComponentBase::error (bool value)
{
  //## begin ComponentBase::error%3AD348E400E5.set preserve=no
  m_error = value;
  //## end ComponentBase::error%3AD348E400E5.set
}

inline bool ComponentBase::compute () const
{
  //## begin ComponentBase::compute%3C20E0DD0057.get preserve=no
  return m_compute;
  //## end ComponentBase::compute%3C20E0DD0057.get
}

inline const bool ComponentBase::fluxSaved () const
{
  //## begin ComponentBase::fluxSaved%3CB5E95902BA.get preserve=no
  return m_fluxSaved;
  //## end ComponentBase::fluxSaved%3CB5E95902BA.get
}

inline void ComponentBase::fluxSaved (bool value)
{
  //## begin ComponentBase::fluxSaved%3CB5E95902BA.set preserve=no
  m_fluxSaved = value;
  //## end ComponentBase::fluxSaved%3CB5E95902BA.set
}

inline const string& ComponentBase::initString () const
{
  //## begin ComponentBase::initString%3E36FBC20380.get preserve=no
  return m_initString;
  //## end ComponentBase::initString%3E36FBC20380.get
}

inline void ComponentBase::initString (const string& value)
{
  //## begin ComponentBase::initString%3E36FBC20380.set preserve=no
  m_initString = value;
  //## end ComponentBase::initString%3E36FBC20380.set
}

inline bool ComponentBase::isSpectrumDependency () const
{
  //## begin ComponentBase::isSpectrumDependency%43E8E45302AA.get preserve=no
  return m_isSpectrumDependency;
  //## end ComponentBase::isSpectrumDependency%43E8E45302AA.get
}

inline void ComponentBase::isSpectrumDependency (bool value)
{
  //## begin ComponentBase::isSpectrumDependency%43E8E45302AA.set preserve=no
  m_isSpectrumDependency = value;
  //## end ComponentBase::isSpectrumDependency%43E8E45302AA.set
}

//## Get and Set Operations for Associations (inline)

inline std::vector<Parameter*>& ComponentBase::parameterSet ()
{
  //## begin ComponentBase::parameterSet%3A8ADC0100A1.get preserve=no
  return m_parameterSet;
  //## end ComponentBase::parameterSet%3A8ADC0100A1.get
}

inline Parameter* ComponentBase::parameterSet (size_t index)
{
  //## begin ComponentBase::parameterSet%3A8ADC0100A1.qualget preserve=no
  return m_parameterSet[index];
  //## end ComponentBase::parameterSet%3A8ADC0100A1.qualget
}

inline CGroupBase* ComponentBase::parent ()
{
  //## begin ComponentBase::parent%3A9E7CF900D5.get preserve=no
  return m_parent;
  //## end ComponentBase::parent%3A9E7CF900D5.get
}

inline void ComponentBase::parent (CGroupBase* value)
{
  //## begin ComponentBase::parent%3A9E7CF900D5.set preserve=no
  m_parent = value;
  //## end ComponentBase::parent%3A9E7CF900D5.set
}

inline const XSModelFunction* ComponentBase::generator () const
{
  //## begin ComponentBase::generator%3E31819F0191.get preserve=no
  return m_generator;
  //## end ComponentBase::generator%3E31819F0191.get
}

inline void ComponentBase::generator (XSModelFunction* value)
{
  //## begin ComponentBase::generator%3E31819F0191.set preserve=no
  m_generator = value;
  //## end ComponentBase::generator%3E31819F0191.set
}

inline MixBase* ComponentBase::mixGenerator () const
{
  //## begin ComponentBase::mixGenerator%3F6F217A01B6.get preserve=no
  return m_mixGenerator;
  //## end ComponentBase::mixGenerator%3F6F217A01B6.get
}

inline void ComponentBase::mixGenerator (MixBase* value)
{
  //## begin ComponentBase::mixGenerator%3F6F217A01B6.set preserve=no
  m_mixGenerator = value;
  //## end ComponentBase::mixGenerator%3F6F217A01B6.set
}

inline const UniquePhotonContainer& ComponentBase::uniquePhotonArray () const
{
  //## begin ComponentBase::uniquePhotonArray%43D6A8280155.get preserve=no
  return m_uniquePhotonArray;
  //## end ComponentBase::uniquePhotonArray%43D6A8280155.get
}

inline void ComponentBase::setUniquePhotonArray (const UniquePhotonContainer& value)
{
  //## begin ComponentBase::setUniquePhotonArray%43D6A8280155.set preserve=no
  m_uniquePhotonArray = value;
  //## end ComponentBase::setUniquePhotonArray%43D6A8280155.set
}

inline void ComponentBase::uniquePhotonArray (const UniqueEnergy* uniqueEnergy, const RealArray& value)
{
  //## begin ComponentBase::uniquePhotonArray%43D6A8280155.qualset preserve=yes
  UniquePhotonContainer::iterator f = m_uniquePhotonArray.find(uniqueEnergy);
  if (f != m_uniquePhotonArray.end() )
  {
          if (f->second.size() != value.size()) f->second.resize(value.size());
	  f->second = value;
  }
  else
  {
  	m_uniquePhotonArray.insert(UniquePhotonContainer::value_type(uniqueEnergy,value));
  }
  //## end ComponentBase::uniquePhotonArray%43D6A8280155.qualset
}

inline const UniquePhotonContainer& ComponentBase::uniquePhotonErrArray () const
{
  //## begin ComponentBase::uniquePhotonErrArray%43D6AE450209.get preserve=no
  return m_uniquePhotonErrArray;
  //## end ComponentBase::uniquePhotonErrArray%43D6AE450209.get
}

inline void ComponentBase::setUniquePhotonErrArray (const UniquePhotonContainer& value)
{
  //## begin ComponentBase::setUniquePhotonErrArray%43D6AE450209.set preserve=no
  m_uniquePhotonErrArray = value;
  //## end ComponentBase::setUniquePhotonErrArray%43D6AE450209.set
}

inline void ComponentBase::uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy, const RealArray& value)
{
  //## begin ComponentBase::uniquePhotonErrArray%43D6AE450209.qualset preserve=yes
  UniquePhotonContainer::iterator f = m_uniquePhotonErrArray.find(uniqueEnergy);
  if (f != m_uniquePhotonErrArray.end() )
  {
          if (f->second.size() != value.size()) f->second.resize(value.size());
	  f->second = value;
  }
  else
  {
  	m_uniquePhotonErrArray.insert(UniquePhotonContainer::value_type(uniqueEnergy,value));
  }
  //## end ComponentBase::uniquePhotonErrArray%43D6AE450209.qualset
}

inline const UniquePhotonContainer& ComponentBase::savedUniquePhotonArray () const
{
  //## begin ComponentBase::savedUniquePhotonArray%43D6B00F032F.get preserve=no
  return m_savedUniquePhotonArray;
  //## end ComponentBase::savedUniquePhotonArray%43D6B00F032F.get
}

inline void ComponentBase::setSavedUniquePhotonArray (const UniquePhotonContainer& value)
{
  //## begin ComponentBase::setSavedUniquePhotonArray%43D6B00F032F.set preserve=no
  m_savedUniquePhotonArray = value;
  //## end ComponentBase::setSavedUniquePhotonArray%43D6B00F032F.set
}

inline void ComponentBase::savedUniquePhotonArray (const UniqueEnergy* uniqueEnergy, const RealArray& value)
{
  //## begin ComponentBase::savedUniquePhotonArray%43D6B00F032F.qualset preserve=yes
  UniquePhotonContainer::iterator f = m_savedUniquePhotonArray.find(uniqueEnergy);
  if (f != m_savedUniquePhotonArray.end() )
  {
          if (f->second.size() != value.size()) f->second.resize(value.size());
	  f->second = value;
  }
  else
  {
  	m_savedUniquePhotonArray.insert(UniquePhotonContainer::value_type(uniqueEnergy,value));
  }
  //## end ComponentBase::savedUniquePhotonArray%43D6B00F032F.qualset
}

//## begin module%3A8AD2F3021E.epilog preserve=yes
//## end module%3A8AD2F3021E.epilog


#endif
